import React, { useEffect } from 'react';
import { useDispatch, useSelector, useStore } from 'react-redux';
import { useRouter } from 'next/router';

import { TAB_GENERAL } from '../constants';
import { INTERNAL } from '@/modules/@common/user/constants/rolesType';

import { getCanReadOnly } from '../helpers/getRestrictions';
import * as selectors from '../redux/selectors';
import {
  createItemAction,
  getItemAction,
  setActiveTabIdAction,
  setErrorByPropAction,
  setInitialAction,
  setScrollToFieldNameAction,
  updateItemAction,
  validateFields,
} from '../redux/slices';
import { getUserPermissionsSelector } from '@/modules/@common/user/redux/selectors';

import { Form, FormContent, FormSection } from '@/modules/@common/Form';
import GeneralTab from './Tabs/GeneralTab/GeneralTab';
import { Button, Stack, Tab, TabContent, Tabs, Typography } from '@/mui/components';

import styles from './Editor.module.scss';

function Editor() {
  const store = useStore();
  const dispatch = useDispatch();
  const router = useRouter();

  const activeTabId = useSelector(selectors.activeTabIdSelector);
  const name = useSelector(selectors.nameSelector);
  const userPermissions = useSelector(getUserPermissionsSelector);

  const id = parseInt(router.query.id, 10);

  const canReadOnly = getCanReadOnly(id, userPermissions);

  useEffect(() => {
    if (id) {
      dispatch(getItemAction({ id }));
    }

    return () => {
      dispatch(setInitialAction());
    };
  }, [id]);

  const tabs = [
    {
      title: 'General',
      id: TAB_GENERAL,
      content: GeneralTab,
    },
  ].filter(Boolean);

  const saveToServerForm = () => {
    const state = store.getState();
    const allProps = selectors.fullAccessToStoreFieldsForValidation(state);

    const { validation, errorList } = validateFields(
      selectors
        .schemeSelector(state)
        .filter(({ tabId, fieldName }) => {
          if (!tabs.some((tab) => tab.id === tabId)) {
            return false;
          }

          if (fieldName === 'account' || fieldName === 'publisherIds' || fieldName === 'publisherId') {
            return allProps.role && allProps.role.type !== INTERNAL;
          }

          if (fieldName === 'email') {
            return !id;
          }

          return true;
        })
        .map(({ fieldName }) => fieldName),
      allProps,
    );

    if (errorList.length) {
      const errorField = errorList.find((error) => error.tabId === activeTabId) ?? errorList[0];

      dispatch(setActiveTabIdAction(errorField.tabId));
      dispatch(setScrollToFieldNameAction(errorField.fieldName));
    } else if (id) {
      dispatch(updateItemAction(id));
    } else {
      dispatch(createItemAction());
    }

    dispatch(setErrorByPropAction(validation));
  };

  return (
    <div className={styles.Wrapper}>
      <Stack direction="column" fullWidth justifyContent="center" className={styles.Title}>
        <Typography component="div" variant="h6" noWrap>
          {id ? `${name} > Settings` : 'New Online Help Configuration'}
        </Typography>
      </Stack>
      <Stack
        spacing={1}
        fullWidth
        direction="row"
        alignItems="center"
        justifyContent="space-between"
        className={styles.Controls}
      >
        {tabs.length > 1 && (
          <Tabs
            size="medium"
            orientation="horizontal"
            value={activeTabId}
            className={styles.Tabs}
            onChange={(event, value) => dispatch(setActiveTabIdAction(value))}
          >
            {tabs.map((tab) => (
              <Tab key={tab.id} label={tab.title} value={tab.id} />
            ))}
          </Tabs>
        )}
        <Stack spacing={2} justifyContent="flex-end" alignItems="center" direction="row">
          <Button
            variant="outlined"
            size="small"
            color="primary"
            shape="rounded"
            onClick={() => router.push('/online-help')}
          >
            Cancel
          </Button>
          {!canReadOnly && (
            <Button variant="contained" size="small" color="primary" shape="rounded" onClick={saveToServerForm}>
              Save
            </Button>
          )}
        </Stack>
      </Stack>
      <Form scrollFieldSelector={selectors.scrollFieldSelector}>
        <FormContent>
          {tabs.map((tab) => {
            const Content = tab.content;

            return (
              <TabContent key={tab.id} component={FormContent} selectedId={activeTabId} id={tab.id}>
                <FormSection>
                  <Content />
                </FormSection>
              </TabContent>
            );
          })}
        </FormContent>
      </Form>
    </div>
  );
}

export default Editor;
